package com.syc.slm.slmbi.controller;

import com.syc.slm.common.core.util.R;
import com.syc.slm.slmbi.vo.InstrumentPanelGroupVo;
import com.syc.slm.slmbi.vo.PanelTreeNodeVo;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

/**
 * @author liangbin
 * @date 2021/3/31
 */
@RestController
@RequestMapping("/panel-tree")
@Api(value = "仪表板树接口")
public class InstrumentPanelTreeController {

    @GetMapping
    @ApiOperation("第一次进入页面,或者点击查询，获取全部分组下的仪表板数据，以及分组数据")
    @ApiImplicitParam(name = "name", value = "分组名称或者仪表板名称")
    public R<List<PanelTreeNodeVo>> loadTrees(@RequestParam(value = "name", required = false) String name) {
        return R.ok();
    }

    @GetMapping("/children")
    @ApiOperation("点击节点获取，该分组下的仪表板信息，以及分组数据")
    @ApiImplicitParams({@ApiImplicitParam(name = "groupId", value = "分组id", required = true),
        @ApiImplicitParam(name = "name", value = "分组名称或者仪表板名称")})
    public R<List<PanelTreeNodeVo>> children(@RequestParam("groupId") String groupId,
        @RequestParam(value = "name", required = false) String name) {
        return R.ok();
    }

    // FIXME 使用场景？
    @GetMapping("/selectInstrumentPanelGroups")
    @ApiOperation("获取所有的仪表板分组以及分组下的仪表板以及仪表板下的组件")
    public R<List<InstrumentPanelGroupVo>> selectInstrumentPanelGroups() {
        return R.ok();
    }

    // TODO 树搜索
}
